<?php
/*
  $Id: auction_finder.php,v 1.0 2003/12/29 Auctionblox Exp $
 
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
 
  Copyright (c) 2003 osCommerce
  
  This file is part of the eBay Auction Manager for osCommerce
  http://www.auctionblox.com/oscommerce
 
  Copyright (c) 2003, AuctionBlox.com  
 
  Released under the GNU General Public License
*/
  require_once(DIR_WS_FUNCTIONS . 'array_ext.php');
  require_once(DIR_WS_CLASSES . 'auction_token.php');
  require_once(DIR_WS_CLASSES . 'auction_request.php');

  class auctionAPI
  {
    // constructor
	function auctionAPI() 
	{
    }
	
	function processResponse($response)
	{
		$arr = array();
		
		$temp = explode("&", $response);
		for($i=0; $i<sizeof($temp); $i++)
		{
			$temp2 = explode("=", $temp[$i]);
 			$arr[urldecode($temp2[0])] = urldecode($temp2[1]);
		}
		
		return $arr;
	}
	
	
	function downloadListings()
	{
		$request = new auctionRequest();
		
		$params['version'] = '200';
		$params['perform'] = 'GET_LISTINGS';
		$params['timestamp'] = date ('YmdHiZ');
		$params['email'] = AUCTIONBLOX_USERID;
		
		$token = new auctionToken();
		$signature = $token->sign($params, AUCTIONBLOX_PASSCODE);

		$params['signature'] = $signature;
		
		$status = $request->send($params);

		$ret = array();
		if ($status != 200) 
		{
			$ret = array('status' => $status,
			             'message' => $request->getStatusMessage());		
		}
		else 
		{
			$ret = $this->processResponse($request->getBody());
			$ret['status'] = $status;
		}
		
		return $ret;
	}
	
	function calculateListing($vars)
	{
		$request = new auctionRequest();
		
		$params['version'] = '200';
		$params['perform'] = 'CALC_LISTING';
		$params['timestamp'] = date ('YmdHiZ');
		$params['email'] = AUCTIONBLOX_USERID;
		
		$token = new auctionToken();
		$signature = $token->sign($params, AUCTIONBLOX_PASSCODE);

		$params['signature'] = $signature;
		$params = array_merge($vars, $params);
		
		$status = $request->send($params);
		
		$ret = array();
		if ($status != 200) 
		{
			$ret = array('status' => $status,
			             'message' => $request->getStatusMessage());
		}
		else 
		{
			$ret = $this->processResponse($request->getBody());
			$ret['status'] = $status;
		}
		
		return $ret;
	}

	function uploadListing($vars)
	{
		$request = new auctionRequest();
		
		$params['version'] = '200';
		$params['perform'] = 'ADD_LISTING';
		$params['timestamp'] = date ('YmdHiZ');
		$params['email'] = AUCTIONBLOX_USERID;
		
		$token = new auctionToken();
		$signature = $token->sign($params, AUCTIONBLOX_PASSCODE);

		$params['signature'] = $signature;
		$params = array_merge($vars, $params);

		$status = $request->send($params);
		
		$ret = array();
		if ($status != 200) 
		{
			$ret = array('status' => $status,
			             'message' => $request->getStatusMessage());
		}
		else 
		{
			$ret = $this->processResponse($request->getBody());
			$ret['status'] = $status;
		}
		
		return $ret;
	}
	
  }
?>
