<?php
/*
  $Id: auction_upload.php,v 1.0 2003/12/29 Auctionblox Exp $
 
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
 
  Copyright (c) 2003 osCommerce
  
  This file is part of the eBay Auction Manager for osCommerce
  http://www.auctionblox.com/oscommerce
 
  Copyright (c) 2003, AuctionBlox.com  
 
  Released under the GNU General Public License
*/
  require_once(DIR_WS_LANGUAGES . $language . '/' . FILENAME_AUCTION_CONSTANTS);
  
  class auctionConstants 
  {
	function getAPIVersions()
	{
		return array(array('id' => '1.0', 'text' => '1.0'));
	}
	
	function getAPIActions()
	{
		return array(
			array('id' => 'insert', 'text' => 'Insert'),
			array('id' => 'update', 'text' => 'Update'),
			array('id' => 'version', 'text' => 'Version'));
	}
	
	function getInsuranceOptions()
	{
		return array(
			array('id' => '0', 'text' => TEXT_INSURANCE_NONE),
			array('id' => '1', 'text' => TEXT_INSURANCE_OPTIONAL),
			array('id' => '2', 'text' => TEXT_INSURANCE_REQUIRED),
			array('id' => '3', 'text' => TEXT_INSURANCE_INCLUDED));
	}
	
	function getShippingTypes()	
	{
		return array(
			array('id' => 'F', 'text' => TEXT_FIXED_SHIPPING),
			array('id' => 'C', 'text' => TEXT_CALCULATED_SHIPPING),
			array('id' => 'N', 'text' => TEXT_FREE_SHIPPING));
	}

	function getListingTypes()	
	{
		return array(
			array('id' => '1', 'text' => TEXT_AUCTION), 
			array('id' => '9', 'text' => TEXT_FIXED_PRICE),
			array('id' => '2', 'text' => TEXT_DUTCH_AUCTION),
			array('id' => '7', 'text' => TEXT_EBAY_STORE));
	}
	
	function getListingTypesShort()	
	{
		return array('1' => TEXT_AUCTION_SHORT, 
					'9' => TEXT_FIXED_PRICE_SHORT,
					'2' => TEXT_DUTCH_AUCTION_SHORT,
					'7' => TEXT_EBAY_STORE_SHORT);
	}

	/*
	0 United States  us  English  
	2  Canada  ca  English  
	3  United Kingdom  uk  English  
	15  Australia  au  English  
	16 Austria at  German  
	23 Belgium (French) befr  French  
	71  France  fr  French  
	77  Germany  de  German  
	101  Italy  it  Italian  
	123 Belgium (Dutch) benl  Dutch  
	146  Netherlands  nl  Dutch  
	186  Spain  es  Spanish  
	193 Switzerland ch  German  
	196 Taiwan tw  Chinese  
	100  eBay Motors     English  
	*/	
	
	function getSites()	
	{
		return array(
				array('id' => 'US', 'text' => TEXT_COUNTRY_US),
				array('id' => 'CA', 'text' => TEXT_COUNTRY_CA),
				array('id' => 'UK', 'text' => TEXT_COUNTRY_UK),
				array('id' => 'AU', 'text' => TEXT_COUNTRY_AU),
				array('id' => 'AT', 'text' => TEXT_COUNTRY_AT),
//				array('id' => '23', 'text' => 'Belgium (French)'),
				array('id' => 'FR', 'text' => TEXT_COUNTRY_FR),
				array('id' => 'DE', 'text' => TEXT_COUNTRY_DE),
				array('id' => 'IT', 'text' => TEXT_COUNTRY_IT),
//				array('id' => '123', 'text' => 'Belgium (Dutch)'),
//				array('id' => 'NL', 'text' => 'Netherlands'),
				array('id' => 'ES', 'text' => TEXT_COUNTRY_ES),
				array('id' => 'CH', 'text' => TEXT_COUNTRY_CH));
//				array('id' => '196', 'text' => 'Taiwan'));
//				array('id' => '100', 'text' => 'eBay Motors'));
	}
	
	function getListingDurations()	
	{
		return array(
				array('id' => '1', 'text' => TEXT_DURATION_1DAY),
				array('id' => '3', 'text' => TEXT_DURATION_3DAY),
				array('id' => '5', 'text' => TEXT_DURATION_5DAY),
				array('id' => '7', 'text' => TEXT_DURATION_7DAY),
				array('id' => '10', 'text' => TEXT_DURATION_10DAY),
				array('id' => '-1', 'text' => '---------------'),
//				array('id' => '20', 'text' => '20 days'),		// real estate?
				array('id' => '30', 'text' => TEXT_DURATION_30DAY),
				array('id' => '60', 'text' => TEXT_DURATION_60DAY),
				array('id' => '90', 'text' => TEXT_DURATION_90DAY),
				array('id' => '120', 'text' => TEXT_DURATION_120DAY),
				array('id' => '-1', 'text' => '----------------'),
				array('id' => 'GTC', 'text' => TEXT_DURATION_GTC));
	}
	
	function getCurrencies()
	{
		$arr = array();

		$currency_query_raw = "select title, code from " . TABLE_CURRENCIES . " order by title";
		$currency_query = tep_db_query($currency_query_raw);
		while ($currency = tep_db_fetch_array($currency_query)) 
		{
			$arr[] = array('id' => $currency['code'], 'text' => $currency['title']);
    	}
		return $arr;
	}
	
	function getShippingLocations()
	{
		return array(
				array('id' => 'D', 'text' => TEXT_SHIPPING_DOMESTIC),
				array('id' => 'I', 'text' => TEXT_SHIPPING_WORLDWIDE),
				array('id' => 'N', 'text' => TEXT_SHIPPING_NONE));
	}
	
	function getRegions()
	{
		return array(0=>array('id' => '0', 'text' => 'Do not list regionally'));
	}
	
	function getGalleryOptions()
	{
		return array(
				array('id' => 'N', 'text' => TEXT_GALLERY_NONE),
				array('id' => 'G', 'text' => TEXT_GALLERY_PICTURE),
				array('id' => 'F', 'text' => TEXT_GALLERY_FEATURED));
	}
}	
?>
