<?php
/*
  $Id: macros.php,v 1.5 2006/03/10 02:23:22 auctionblox Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  /**
   * @package abxMacrosManager
   */
  class abxMacrosManager extends abxMacros 
  {
    function productCustomMacros()
    {
        return array(

            'PRODUCTS_PRICE_FORMATTED',
            'PRODUCTS_WITH_GST',
            'BIN_PRICE',
            'PRODUCTS_IMAGE_POPUP',
            'ADDITIONAL_IMAGES_POPUP',
			'VERTICAL_ADDITIONAL_IMAGES_POPUP',
        );
    }
    
    function productImageMacros()
    {
      return array(
        'PRODUCTS_IMAGE',
        'PRODUCTS_IMAGE_MED',
        'PRODUCTS_IMAGE_LRG',
        'PRODUCTS_IMAGE_SM_1',
        'PRODUCTS_IMAGE_XL_1',
        'PRODUCTS_IMAGE_SM_2',
        'PRODUCTS_IMAGE_XL_2',
        'PRODUCTS_IMAGE_SM_3',
        'PRODUCTS_IMAGE_XL_3',
        'PRODUCTS_IMAGE_SM_4',
        'PRODUCTS_IMAGE_XL_4',
        'PRODUCTS_IMAGE_SM_5',
        'PRODUCTS_IMAGE_XL_5',
        'PRODUCTS_IMAGE_SM_6',
        'PRODUCTS_IMAGE_XL_6',
        'PICTURE1_URL',
        'PICTURE2_URL',
        'PICTURE3_URL',
        'PICTURE4_URL',
        'PICTURE5_URL',
        'PICTURE6_URL',
        'PICTURE7_URL',
        'PICTURE8_URL'
      );
    }    

    function runProductCustomMacros(&$target, &$product)
    {
        $target =& $this->runMacro('PRODUCTS_PRICE_FORMATTED', '$' . number_format($product['products_price'],2), $target);
        $target =& $this->runMacro('PRODUCTS_WITH_GST', $product['products_price'], $target);
        $target =& $this->runMacro('BIN_PRICE', $product['products_price'] * 1.05, $target);
        
        $target =& $this->runMacro('PRODUCTS_IMAGE_POPUP',
                                   $this->createProductsImagePopup($target, $product),
                                   $target);

        $target =& $this->runMacro('ADDITIONAL_IMAGES_POPUP',
                                   $this->createAdditionalImagesPopup($target, $product),
                                   $target);
		$target =& $this->runMacro('VERTICAL_ADDITIONAL_IMAGES_POPUP',
                                   $this->createVerticalAdditionalImagesPopup($target, $product),
                                   $target);
        
        return $target;
    }
    
    function createProductsImagePopup(&$target, &$product)
    {
      $images .= '<table id="abx-image-popup" width="100%"><tr>';
      
      if(strlen($product['products_image']) > 0)
        $images .= $this->createImageRow($product['products_image'], $product['products_image_lrg']);

      $images .= '</tr></table>';
      
      return $images;
    }
    
    function createAdditionalImagesPopup(&$target, &$product)
    {
      $images = '<table id="abx-horizontal-images" bordercolor="#e4eafc" border="5" width="100%" cellspacing="1"><tr valign="bottom">';

      if(strlen($product['products_image_sm_1']) > 0 && $product['products_image_sm_1'] != 'NULL')
        $images .= $this->createImageRow($product['products_image_sm_1'], $product['products_image_xl_1']);

      if(strlen($product['products_image_sm_2']) > 0 && $product['products_image_sm_2'] != 'NULL')
        $images .= $this->createImageRow($product['products_image_sm_2'], $product['products_image_xl_2']);

      if(strlen($product['products_image_sm_3']) > 0 && $product['products_image_sm_3'] != 'NULL')
        $images .= $this->createImageRow($product['products_image_sm_3'], $product['products_image_xl_3']);

      if(strlen($product['products_image_sm_4']) > 0 && $product['products_image_sm_4'] != 'NULL')
        $images .= $this->createImageRow($product['products_image_sm_4'], $product['products_image_xl_4']);

      if(strlen($product['products_image_sm_5']) > 0 && $product['products_image_sm_5'] != 'NULL')
        $images .= $this->createImageRow($product['products_image_sm_5'], $product['products_image_xl_5']);

      if(strlen($product['products_image_sm_6']) > 0 && $product['products_image_sm_6'] != 'NULL')
        $images .= $this->createImageRow($product['products_image_sm_6'], $product['products_image_xl_6']);
      $images .= '</tr></table>';
      
      return $images;
    }
	
	function createVerticalAdditionalImagesPopup(&$target, &$product)
    {
      $images = '<table id="abx-vertical-images" bordercolor="#e4eafc" border="5" width="100%" cellspacing="1">';

      if(strlen($product['products_image_sm_1']) > 0 && $product['products_image_sm_1'] != 'NULL')
        $images .= '<tr valign="bottom">' . $this->createImageRow($product['products_image_sm_1'], $product['products_image_xl_1']) . '</tr>';

      if(strlen($product['products_image_sm_2']) > 0 && $product['products_image_sm_2'] != 'NULL')
        $images .= '<tr valign="bottom">' . $this->createImageRow($product['products_image_sm_2'], $product['products_image_xl_2']) . '</tr>';

      if(strlen($product['products_image_sm_3']) > 0 && $product['products_image_sm_3'] != 'NULL')
        $images .= '<tr valign="bottom">' . $this->createImageRow($product['products_image_sm_3'], $product['products_image_xl_3']) . '</tr>';

      if(strlen($product['products_image_sm_4']) > 0 && $product['products_image_sm_4'] != 'NULL')
        $images .= '<tr valign="bottom">' . $this->createImageRow($product['products_image_sm_4'], $product['products_image_xl_4']) . '</tr>';

      if(strlen($product['products_image_sm_5']) > 0 && $product['products_image_sm_5'] != 'NULL')
        $images .= '<tr valign="bottom">' . $this->createImageRow($product['products_image_sm_5'], $product['products_image_xl_5']) . '</tr>';

      if(strlen($product['products_image_sm_6']) > 0 && $product['products_image_sm_6'] != 'NULL')
        $images .= '<tr valign="bottom">' . $this->createImageRow($product['products_image_sm_6'], $product['products_image_xl_6']) . '</tr>';
      $images .= '</table>';
      
      return $images;
    }
    
    function createImageRow(&$smallImage, &$largeImage)
    {   
      $server = HTTP_CATALOG_SERVER . DIR_WS_CATALOG_IMAGES;

      return '<td align="center">' .
             '<a href="' . $server . $largeImage . '" target="_popup">' .
             '<img src="' . $server . $smallImage . '" border="0" hspace="5" vspace="5"><br/>' .
             '<img src="' . $server . DIR_WS_MODULES . 'auctionblox/images/image_enlarge.gif" border="0" alt="Click to enlarge" title="Click to enlarge">' .
             '</a>' .
             '</td>';
    }
  }
?>