<?php
/*
  $Id: abxCart.php,v 1.18 2007/10/15 22:46:02 devosc Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  class_exists('shoppingCart') || require_once(DIR_WS_CLASSES . 'shopping_cart.php');
  class_exists('abxCheckout')  || require_once(dirname(__FILE__) . '/abxCheckout.php');
  require_once (dirname(__FILE__) .'/../functions/abx_currencies.php');

  class abxCart extends shoppingCart {

    var $email;

    function abxCart($email_address = '')
    {
      $this->email = $email_address;
      parent::shoppingCart();
    }

    // This function does not ALWAYS set the order id, but at least it updates the status
    // to checked out
    function reset($reset_database = false, $order_id = 0)
    {
      global $abxDatabase;
      
      parent::reset($reset_database);

      if ($reset_database == true) {
      
      	if($order_id === 0)
      	{
      		// find the last order id in the history table -- that's our target order.  surely, we don't have
      		// a site that is THAT active
      	  $orders_status = $abxDatabase->fetch_row("select orders_id from " . TABLE_ORDERS_STATUS_HISTORY . " order by orders_status_history_id desc limit 1");
      		$order_id = $orders_status['orders_id'];
      	}

        // Mark the items in the shopping cart completed.
        $abxCheckout = new abxCheckout();

        $auctionProducts = $this->internal_get_auction_products();

        foreach($auctionProducts as $key => $auction) {

          //quick fudge to accomodate selected admin Sales Order Entry
          if (isset($auction['is_excluded']) && $auction['is_excluded'] === true)
            continue;

          $auctionProduct = array(
            'ID'       => $auction['auction_basket_id'],
            'statusID' => $abxCheckout->CHECKEDOUT,
            'ordersID' => $order_id
          );

          $abxCheckout->update(null, $auctionProduct);

        }

      }
    }
    
    //@@deprecated
    function checkStatus()
    {
    }

    function internal_get_auction_products()
    {
      global $abxDatabase, $currencies;

      if (isset($this->email) === false || strlen($this->email) == 0) {

        if (isset($_SESSION['g_auction_email_address']) && strlen($_SESSION['g_auction_email_address']) > 0) {

          $this->email = $_SESSION['g_auction_email_address'];

        } else {

          global $customer_id;

          if (isset($customer_id) && $customer_id >= 0) {

            $customer = $abxDatabase->fetch_row("select customers_email_address from " . TABLE_CUSTOMERS . " where customers_id = ". (int)$customer_id);

            $this->email = @$customer['customers_email_address'];

          }

        }
      }

      $abxCheckout = new abxCheckout();

      $auctions = $abxCheckout->getSales($this->email);

      $products_array = array();

      if (is_array($auctions)) {

        global $languages_id;

        foreach($auctions as $key => $auction) {
          $products = $abxDatabase->fetch_row("select p.products_id, pd.products_name, p.products_model, p.products_image, p.products_price, p.products_weight, p.products_tax_class_id from " . TABLE_PRODUCTS . " p, " . TABLE_PRODUCTS_DESCRIPTION . " pd where p.products_id = '" . (int)$auction['product_id'] . "' and pd.products_id = p.products_id and pd.language_id = '" . (int)$languages_id . "'");

          if (empty($products) === false) {
            $products_array[] = array(
              'id'                => $products['products_id'],
              'name'              => $auction['ext_title'] . " (eBay #" . $auction['ext_id'] . ", " . $auction['buyer_id'] . ")",
              'model'             => $products['products_model'],
              'image'             => $products['products_image'],
              'quantity'          => $auction['qty'],
              'weight'            => $products['products_weight'],
              'currency'          => $auction['currency'],
              'tax_class_id'      => $products['products_tax_class_id'],
              'price'             => abx_currencies_convertCurrency($auction['price_end'], $auction['currency']),
              'final_price'       => abx_currencies_convertCurrency($auction['price_end'], $auction['currency']),
              'shipping_type'     => $auction['shipping_type'],
              'shipping'          => abx_currencies_convertCurrency($auction['shipping'], $auction['currency']),
              'shipping_global'   => abx_currencies_convertCurrency($auction['shipping_global'], $auction['currency']),
              'insurance'         => abx_currencies_convertCurrency($auction['insurance'], $auction['currency']),
              'insurance_option'  => $auction['insurance_option'],
              'is_auction_item'   => true,
              'auction_basket_id' => $auction['id'],
              'item_url'          => $auction['item_url'],
              'attributes'        => array()
            );
          } else {

            $sImage = '../'.DIR_WS_MODULES.'auctionblox/images/product.gif';

            // product ID not set
            // We can't use weight based shipping since we don't know the weight
            $products_array[] = array(
              'id'                => $auction['ext_id'],
              'name'              => $auction['ext_title'] . " (eBay #" . $auction['ext_id'] . ", " . $auction['buyer_id'] . ")",
              'model'             => '',
              'image'             => $sImage,
              'quantity'          => $auction['qty'],
              'weight'            => -1,
              'tax_class_id'      => 0,
              'price'             => abx_currencies_convertCurrency($auction['price_end'], $auction['currency']),
              'final_price'       => abx_currencies_convertCurrency($auction['price_end'], $auction['currency']),
              'shipping_type'     => $auction['shipping_type'],
              'shipping'          => abx_currencies_convertCurrency($auction['shipping'], $auction['currency']),
              'shipping_global'   => abx_currencies_convertCurrency($auction['shipping_global'], $auction['currency']),
              'insurance'         => abx_currencies_convertCurrency($auction['insurance'], $auction['currency']),
              'insurance_option'  => $auction['insurance_option'],
              'is_auction_item'   => true,
              'auction_basket_id' => $auction['id'],
              'item_url'          => $auction['item_url'],
              'attributes'        => array()
            );

          }

        }

      }

      return $products_array;
    }

    function internal_get_store_products()
    {
      // Fix for bad programming in shopping cart
      return parent::get_products();
    }


    function get_products()
    {
      $store_products_array = $this->internal_get_store_products();

      // Fix for bad programming in shopping cart
      if ($store_products_array === false)
        $store_products_array = array();

      $auction_products_array = $this->internal_get_auction_products();

      return array_merge($auction_products_array, $store_products_array);
    }

    // get total number of items in cart
    function count_contents()
    {
      $count = 0;

      foreach($this->get_products() as $key => $product)
        $count += $product['quantity'];

      return $count;
    }

    function count_auction_contents()
    {
      $count = 0;

      foreach($this->internal_get_auction_products() as $key => $product)
        $count += $product['quantity'];

      return $count;
    }

    function count_store_contents()
    {
      $count = 0;

      foreach($this->internal_get_store_products() as $key => $product)
        $count += $product['quantity'];

      return $count;
    }

    function calculate()
    {
      parent::calculate();

      $auctionProducts = $this->internal_get_auction_products();

      if (is_array($auctionProducts) === false)
        return 0;

      reset($auctionProducts);

      foreach($auctionProducts as $key => $auctionProduct) {

        $qty = $auctionProduct['quantity'];

        //$prid = $product['products_id'];

        $products_tax = tep_get_tax_rate($auctionProduct['tax_class_id']);

        $products_price = $auctionProduct['price'];

        $products_weight = $auctionProduct['weight'];

        $this->total += tep_add_tax($products_price, $products_tax) * $qty;

        $this->weight += ($qty * $products_weight);

      }
    }

  }//end class
?>